#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;

const int NMax = 200005;

int N,M;
double v;
pair < double, double > Draco[NMax], Harry[NMax];

void Read()
{
    scanf("%d%d", &N, &M);

    scanf("%lf", &v);

    for(int i=1; i<=N; ++i)
        scanf("%lf%lf", &Harry[i].first, &Harry[i].second);

    for(int i=1; i<=M; ++i)
        scanf("%lf%lf", &Draco[i].first, &Draco[i].second);
}

double calcul(double x1, double y1, double x2, double y2)
{
    return sqrt((y2-y1)*(y2-y1)+(x2-x1)*(x2-x1));

}

void Diam_Opus(double ax, double ay, double bx, double by ,double &vx, double &vy)
{
    int i,j;

    double xvraji, yvraji;

    double difx=bx-ax;
    double dify=by-ay;

    if(difx>0)
        xvraji=ax-difx;

    else
        xvraji=ax+abs(difx);

    if(dify>0)
        yvraji=ay+abs(dify);

    else
        yvraji=ay-(dify);

    vx=xvraji;
    vy=yvraji;
}

void Solve1()
{
    int i,j;

    double sum=0;
    double lastx=0, lasty=0;

    for(i=1, j=1; i<=N && j<=M; ++j, ++i)
    {
        double vx, vy;
        Diam_Opus(Harry[i].first, Harry[i].second, Draco[j].first, Draco[j].second, vx, vy);
        sum+=calcul(lastx,lasty,vx,vy);
        lastx=vx;
        lasty=vy;
    }

    while(j<=M)
    {
        double vx, vy;
        Diam_Opus(Harry[N].first, Harry[N].second, Draco[j].first, Draco[j].second, vx, vy);
        sum+=calcul(lastx,lasty,vx,vy);
        lastx=vx;
        lasty=vy;
        ++j;
    }

    while(i<=N)
    {
        double vx, vy;
        Diam_Opus(Harry[N].first, Harry[N].second, Draco[M].first, Draco[M].second, vx, vy);
        sum+=calcul(lastx,lasty,vx,vy);
        lastx=vx;
        lasty=vy;
        ++i;
    }

    printf("%lf", sum);
}

void Solve2()
{
    double distHr=calcul(0,0,Harry[1].first, Harry[1].second);

    double distDr=distHr/v;

    double distTotal=calcul(0,0,Draco[1].first, Draco[1].second);

    double punctx, puncty;

    puncty=(distDr*Draco[1].second)/distTotal;
    punctx=(distDr*Draco[1].first)/distTotal;

    double vx,vy, lx,ly, sum;
    Diam_Opus(Harry[1].first, Harry[1].second, punctx, puncty, vx, vy);
    sum+=calcul(0,0,vx,vy);

    Diam_Opus(Harry[1].first, Harry[1].second, Draco[1].first, Draco[1].second, lx,ly);
    sum+=calcul(vx,vy,lx,ly);

    printf("%lf", sum);
}

void Solve3()
{
    double lasthx=0, lasthy=0, lastdx=0, lastdy=0 ,lastx=0,lasty=0, sum=0;
    int i,j;

    for(i=1, j=1; i<=N && j<=M; ++j, ++i)
    {
        double distHr=calcul(lasthx,lasthy,Harry[i].first, Harry[i].second);
        double distDr=distHr/v;

        double distTotal=calcul(lastdx,lastdy,Draco[j].first, Draco[j].second);

        double punctx, puncty;

        puncty=(distDr*Draco[j].second)/distTotal;
        punctx=(distDr*Draco[j].first)/distTotal;

        double vx,vy, lx,ly;
        Diam_Opus(Harry[i].first, Harry[i].second, punctx, puncty, vx, vy);
        sum+=calcul(lastx,lasty,vx,vy);

        double distramasa=calcul(Draco[j].first, Draco[j].second, lastdx, lastdy)-distDr;

        double pctx, pcty;

        double distHarry=distramasa*v;

        double yf=abs(Draco[j].second-puncty);
        double xf=abs(Draco[j].first-punctx);

        pcty=(distramasa*yf)/distHarry;
        pctx=(distramasa*xf)/distHarry;

        Diam_Opus(pctx, pcty, Draco[j].first, Draco[j].second, lx,ly);
        sum+=calcul(vx,vy,lx,ly);

        lastx=vx;
        lasty=vy;
        lasthx=pctx;
        lasthy=pcty;
        lastdx=Draco[j].first;
        lastdy=Draco[j].second;
    }

    while(j<=M)
    {
        double vx,vy;
        Diam_Opus(Harry[N].first, Harry[N].second, Draco[j].first, Draco[j].second, vx, vy);
        sum+=calcul(lastx,lasty,vx,vy);
        ++j;
    }

    printf("%lf", sum);
}


int main()
{
    freopen("hogwarts.in", "r", stdin);
    freopen("hogwarts.out", "w", stdout);

    Read();
    if(v<=1)
        Solve1();

    else if(N==1 && M==1)
        Solve2();

    else
        Solve3();

    return 0;
}
